-- Create Module
local BaikActionbar = LibStub("AceAddon-3.0"):GetAddon("BaikActionbar")
local UiHelper = {}

-- Add module to addon
BaikActionbar.UiHelper = UiHelper

-- Private Variables
local HiddenFrame = CreateFrame("Frame", "BaikActionbar_HiddenFrame", UIParent)
HiddenFrame:Hide()
local SetPointNil = function(frame, point, anchor, anchorPt, xOff, yOff) end

-- UiHelper API
function UiHelper:SetPoint(frame, point, anchor, anchorPt, xOff, yOff)
    -- Add set point
    if frame.temp_point then
        frame.SetPoint = frame.temp_point
    end

    -- Update UI
    frame:ClearAllPoints()
    frame:SetPoint(point, anchor, anchorPt, xOff, yOff)
    frame.ignoreFramePositionManager = true

    -- Remove set point
    frame.temp_point = frame.SetPoint
    frame.SetPoint = SetPointNil
end

function UiHelper:SetPointFinal(frame, point, anchor, anchorPt, xOff, yOff)
    self:SetPoint(frame, point, anchor, anchorPt, xOff, yOff)
    frame.SetPoint = SetPointNil
end

function UiHelper:Hide(frame)
    frame:SetParent(HiddenFrame)
end

function UiHelper:HideFinal(frame)
    self:Hide(frame)
    frame.SetParent = function() end
end

function UiHelper:HideAllFinal(table)
    for _, frame in pairs(table) do
        self:HideFinal(frame)
    end
end
